
//Robo Cup  Commentater  
import java.awt.*;
import java.net.*;
import java.io.*;
import java.awt.event.*;
import java.util.*;
//
//default main window
//
public class MainWindow extends Frame implements WindowListener, Observer{

	//header panel objects
	TextField	status_l ;		/* for left team */
	TextField	status_r ;		/* for right team */
	Label		status_t ;		/* to display time */
	Label		status_m ;		/* to display play mode */
	Label		goalscore_l ;
	Label		goalscore_r ;
	Panel 		headerPanel;
	String teamNameL, teamNameR;

	//field objests
	CField 		field;

	//analyzing field information onject
	AnalyzeInfo aInfo; 

	//connecter for soccerserver
	CPort 		port;
	 
	//color of team name panel
	static Color color_r = Color.red.brighter(); 
	static Color color_l = Color.yellow;
		
	//footer panel object
	Panel evalPanel;

	Label header1;
	Label header2;

	Label formNormal;
	Label formNormalEval;
	Label formDefensive;
	Label formDefensiveEval;
	Label formOffensive;
	Label formOffensiveEval;

        Panel footerPanel;
        KeiseiGraph kg;

	//east panel object
	EastPanel eastPanel;
 
	//constructor
	MainWindow(){

		//set title
		super("on-line LogMonitor");
	 	
		//initializing this window
		init();
	      
		Thread.yield();

	}	
	//start coach (connect soccerserver and start cport thread)
	public void start(){

		port.start();

	}

	//initializing this window

	void init(){
		//t[̐ݒ

		this.setLayout(new BorderLayout());
		this.setBackground(Color.white);

		//Creating Panel of menu bar & buttons & textField.	

		createHeaderPanel();
		createField();
		createFooterPanel();

		//create east panel
		eastPanel = new EastPanel();
		this.add("East",eastPanel);

		//set window size

		setSize(field.getPreferredSize());
		pack();

                //this object add window listener 
		addWindowListener(this);

	}	

	public void connect(String host, int portNum, String MyTeamName){

		port = new CPort(getMainWindow(), host, portNum, MyTeamName);	
		Thread.yield();
		
	}
	
	public MainWindow getMainWindow(){
		return this;
	}
	
	public CField getCField(){
		return field;
	}

	public void update(Observable o, Object arg){

		ReplayInfo rInfo = (ReplayInfo)o;
		status_l.setText(rInfo.getTeamName(CParam.CType_LEFT).trim()+":"+rInfo.getScore(0));
		status_r.setText(rInfo.getTeamName(CParam.CType_RIGHT).trim()+":"+rInfo.getScore(1));
		status_t.setText(new Integer(rInfo.getTime()).toString());
	    
	}
		

	private void createFooterPanel(){

    		footerPanel = new Panel();
		footerPanel.setLayout(new FlowLayout(FlowLayout.CENTER,20,20));
		
		evalPanel =new Panel();
		evalPanel.setLayout(new GridLayout(4,2));
		
		header1 = new Label("Formation");
		header2 = new Label("Eval. value"); 

		formNormal = new Label("NORMAL");
                formOffensive = new Label("OFFENSIVE");
		formDefensive = new Label("DEFENSIVE");
                status_t.setAlignment(status_t.CENTER);

		formNormalEval = new Label("-");
		formOffensiveEval = new Label("-");
		formDefensiveEval  = new Label("-");
		formNormalEval.setAlignment(formNormalEval.CENTER);
		formOffensiveEval.setAlignment(formOffensiveEval.CENTER);
		formDefensiveEval.setAlignment(formDefensiveEval.CENTER);

		evalPanel.add(header1);
		evalPanel.add(header2);

		evalPanel.add(formNormal);
		evalPanel.add(formNormalEval);

		evalPanel.add(formDefensive);
		evalPanel.add(formDefensiveEval);
		
		evalPanel.add(formOffensive);
 		evalPanel.add(formOffensiveEval);
		
		//footerPanel.setHeight(keisei.getHeight());
		kg = new KeiseiGraph();
	       
    		footerPanel.add(evalPanel); 
		footerPanel.add(kg);

		this.add("South",footerPanel);

	}

		
	private void createHeaderPanel(){

		headerPanel = new Panel();
		headerPanel.setLayout(new GridLayout(1,6));
		status_l = new TextField("Team_L");
        	status_l.setEditable(false);
        	status_l.setBackground(color_l);
		status_r = new TextField("Team_R");
        	status_r.setEditable(false);
        	status_r.setBackground(color_r);
		status_t = new Label("00000");
		status_t.setAlignment(status_t.CENTER);
		status_m = new Label("before_kick_off");
		status_m.setAlignment(status_m.CENTER);		
		goalscore_l = new Label(" ");
		goalscore_r = new Label(" ");
		
		teamNameL = new String("Team_L");
		teamNameR = new String("Team_R");
	
		headerPanel.add(status_l);
		headerPanel.add(goalscore_l);
		headerPanel.add(status_m);
		headerPanel.add(status_t);
		headerPanel.add(goalscore_r);
		headerPanel.add(status_r);
		// Adding field to this applet.
		//this.add("North",headerPanel);


	}

	//åեɤκ
	private void createField(){
		field = new CField();
		this.add("Center", field);
	}		
	
	public void windowClosed(WindowEvent event) {
    	}
   	public void windowDeiconified(WindowEvent event) {
   	}
   	public void windowIconified(WindowEvent event) {
   	}
   	public void windowActivated(WindowEvent event) {
   	}
   	public void windowDeactivated(WindowEvent event) {
   	}
   	public void windowOpened(WindowEvent event) {
   	}
   	public void windowClosing(WindowEvent event) {
           System.exit(0);

   	}   

}



	















