/**********************************************************/
/**********************************************************/
/*                                                        */
/*                                                        */
/*        $B%\!<%k$N>pJs$H%9%T!<%I$H0LCV$r5a$a$k(B            */
/*                                                        */
/*                                                        */
/**********************************************************/
/**********************************************************/

import java.io.*;

class Ball implements Serializable
{
        transient MyBody  my;
        transient SoccerLib slib; 

	static 	int	time;

	static  double 	dis;
	static  double	dir;
	static  double 	disch;
	static  double  dirch;

	static 	double	x;
	static 	double	y;

	static 	double  vel;
	static 	double	vel_x;
	static 	double	vel_y;

        int     tmp_time; /* $BAv$j9~$`;~(B,$BJ}8~$rJQ$($k2s?t(B */  


        public Ball()
         {
	   my  = new MyBody();
	   slib = new SoccerLib();
	   if(my.num == 2 || my.num == 3 )	   
		tmp_time = 4;
	   else 
		tmp_time = 6;			
	 }    


        /* $B%\!<%k$N0LCV$H%Y%m%7%F%#$r5a$a$k(B */
	public void get_ballpos(ObjectInfo obj)
	{
	        double  tmp_x, tmp_y;
		
		double  t1,t2,t3;

		dis = obj.m_distance; 
		dir = obj.m_direction;
		disch = obj.m_distChange;
		dirch = obj.m_dirChange;

//		System.out.println("x,y = "+my.x+" "+my.y);
		
		/* $B%\!<%k$N0LCV$r5a$a$k(B */
//		System.out.println("my_dir "+my.dir);
		y = my.y + dis * slib.Sin(slib.Deg2Rad(dir + my.dir));
		x = my.x + dis * slib.Cos(slib.Deg2Rad(dir + my.dir));

		//	System.out.println("Ball dis" + dis + " dir " + dir + " x  " 
                //      + x + " y " + y + " ");

                /* $B%\!<%k$N%Y%m%7%F%#$r5a$a$k(B(Manual$B;2>H(B) */
		tmp_x = disch * slib.Cos2Rad(dir) 
                   + slib.Deg2Rad(dirch) * dis * slib.Sin2Rad(dir); 
		tmp_y = disch * slib.Sin2Rad(dir) 
                   + slib.Deg2Rad(dirch) * dis * slib.Cos2Rad(dir); 
		vel_x = tmp_x * slib.Cos2Rad(my.dir) 
                   + tmp_y * slib.Sin2Rad(my.dir) + my.vel_x;
		vel_y = tmp_y * slib.Cos2Rad(my.dir)   
		   + tmp_y * slib.Sin2Rad(my.dir) + my.vel_y;
		vel = slib.Pit(vel_x,vel_y);   

		/* $B50F;$NM=B,(B */
		if(dis < 20.0)
                {
		  predict_ball();
		}
         }
         
         /**************************/          
         /* $B%\!<%k$N50F;$rM=B,$9$k(B */
         /**************************/          
         public void predict_ball()
         {
	     double tmp_vel_x, tmp_vel_y;
             int    i;
             int    s = 15;
	     boolean predict_flag = false;
             double pre_x[] = new double[s];
	     double pre_y[] = new double[s];
             pre_x[0] = x;
             pre_y[0] = y;
             tmp_vel_x = vel_x;
             tmp_vel_y = vel_y;

             /* S$BIC8e$^$G$N50F;$rM=B,$9$k(B */
             for(i = 1; i < s ; i++)  
             {
	        pre_x[i] = pre_x[i-1] + tmp_vel_x; 
	        pre_y[i] = pre_y[i-1] + tmp_vel_y; 
                tmp_vel_x *= slib.ball_decay;
                tmp_vel_y *= slib.ball_decay;  

                /* $B%\!<%k$,=3$l$kHO0OFb$rDL$k$J$i:#$N>l=j$rBT$D(B */
                if(pre_x[i] > my.x - slib.kick_able && 
                   pre_x[i] < my.x + slib.kick_able && 
                   pre_y[i] > my.y - slib.kick_able && 
                   pre_y[i] < my.y - slib.kick_able )
		  {
	               predict_flag = false;                  		       
                       break;
		  }

                if(slib.predict_decision(pre_x[i],pre_y[i]))   
                {
	           predict_flag = true;                  
                }
	     }
             
     //	     System.out.println("test2");

             if(predict_flag)
                predict_pos(pre_x, pre_y, s);
	 }

        /********************************/
        /* $B%\!<%k$NDI$$IU$/$J$iAv$j9~$`(B */
        /********************************/
        public void predict_pos(double x[], double y[], int s) 
        {
	    int     i;
            int     t_count; /* $BL\E*2H$^$G3]$k;~4V(B */
            int     tyotto; /* $BAv$j9~$`>l=j$X$N;~4V(B */
            double  pre_t[] = new double[s]; /* $BAv$j9~$`$N$K3]$k;~4V(B */
            double  tmp_max_pow = 90.0;
            double  tmp_vel   = my.vel; 
	    double  tmp_vel_x = my.vel_x; 
	    double  tmp_vel_y = my.vel_y;
            double  tmp_stamina = my.stamina;
            double  tmp_dis, tmp_pow;

            for(i=2; i<s ; i++)
            {
               tmp_dis = slib.Calc_dis(x[i], y[i]);
               t_count=0;   

               /* $BL\E*CO$^$G3]$k;~4V$r7W$k(B */
               while(tmp_dis > 0.0)
               {
	          tmp_pow = slib.Com_max((tmp_dis-tmp_vel)/0.01/1.6,
		    (1.0 - tmp_vel)/1.6);
                  if(tmp_stamina < tmp_max_pow)   
         	    tmp_pow = tmp_stamina;   
        	  else   
        	    tmp_pow = tmp_max_pow;   
   	          if(tmp_pow>tmp_max_pow)   
        	      tmp_pow = tmp_max_pow;   
	     
        	  tmp_stamina -= tmp_pow;   
         	  tmp_vel += tmp_pow * slib.dash_rate;   
        	  tmp_dis = tmp_dis - tmp_vel;   
        	  t_count += 1;   
        	  tmp_stamina += slib.stamina_inc;   
        	  tmp_vel *= slib.agent_decay;   
        	  if(t_count > s-tmp_time)
        	    break;
		    }   
                pre_t[i] = t_count - i;   
             }
     
            for(i=2;i<(s-tmp_time-2);i++)   
            {   
              /*************************************/
              /* $B<+J,(B - $B%\!<%k$GDI$$IU$1$k$+H=Dj(B  */
              /*************************************/
              if( pre_t[i]>3)   
            	{   
        	  my.pursue_flag = true;
        	  tyotto = i + tmp_time;  
                  my.go_x = x[tyotto];   
        	  my.go_y = y[tyotto];   
        	  my.p_time = my.time + tyotto /*+ 3*/;
   
        	  if(slib.predict_decision(my.go_x,my.go_y)==false)  
        	      my.pursue_flag = false;  
	          /* $B%U%#!<%k%I30$J$iDI$o$J$$(B */
        	  else if(my.go_x < -slib.pitch_l/2.0 && 
		          my.go_x >  slib.pitch_l/2.0 &&
        	          my.go_y > -slib.pitch_w/2.0 && 
                          my.go_y <  slib.pitch_w/2.0 )  
        	          my.pursue_flag = false;  

		  break;
	         }   
            }   

	}
}





