/*****************************************/
/* 					 */
/*        	 Brain.java              */
/*		$@%"%/%7%g%sItJ,(J	  	 */
/* 					 */
/*****************************************/

import java.io.*;
import java.lang.*;
import java.util.*;

class Brain implements SensorInput,Runnable
{  
	private  Memory			m_memory;		  
	private  PlayerPos		m_playerpos; 
	private  CommonSkill		cskill;
	private	 CalcPos		calcpos;	
	private  SendCommand		aki;
        private  Ball                   ball;
	private	 long			see_time; /* $@;k3P>pJs$rF@$?<B;~4V(J */
        private  MyBody                 my;
        private  SoccerLib              slib;
        private  Writer                 writer;

	volatile private boolean 	m_timeOver;  
	final	 static int		X = 0, Y = 1;
        private  String                 strobj; 
	private  byte			byteobj[];
	private  int     		n=0;
	Thread   brain;

	public Brain(SendCommand Aki)
	{
		aki			= Aki;
		m_timeOver 		= false;  
		m_memory 		= new Memory();  
		m_playerpos		= new PlayerPos();
		cskill			= new CommonSkill(aki);
		calcpos			= new CalcPos();
		ball                    = new Ball();	
		my                      = new MyBody();
		slib                    = new SoccerLib();
		writer                  = new Writer();
		my.load_flag            = false; 
		my.mode			= 4;
		m_playerpos.get_Pos(MyBody.num);
		if(my.num == 2 || my.num == 3)
			n = my.num + 5;
		else if(my.num == 7 || my.num == 8)
			n = my.num - 5;

		start();
	}  

	public void start()
	{
		if(brain == null)
		{
			brain = new Thread(this);
			brain.start();
		}
	}

	public void stop()
	{
		if(brain != null)
		{
//			brain.stop();
			brain = null;
		}
	}	


        /***********************/
        /* 100ms$@Kh$K>pJs$NJdB-(J */
        /***********************/
        public void handler()
        {
	  /* $@%W%l%$%d!<$N>pJs(J */
	  my.x += my.vel_x;
	  my.y += my.vel_y;

	  my.vel *= SoccerLib.agent_decay;
	  my.vel_x *= SoccerLib.agent_decay;
	  my.vel_y *= SoccerLib.agent_decay;
	  my.dir = SoccerLib.restrict(my.dir);

	  my.stamina += SoccerLib.stamina_inc;
	  my.stamina = 
	    SoccerLib.cut(SoccerLib.StaminaMax, 0.0, my.stamina); 

	  /* $@%\!<%k$N>pJs(J */

	  ball.x += ball.vel_x;
	  ball.y += ball.vel_y;
//	  ball.dir = SoccerLib.Calc_dir(ball.x, ball.y);
//	  ball.dis = SoccerLib.Calc_dis(ball.x, ball.y);

//	  System.out.println("han m " + my.x + " " + my.y + " " + my.dir + " ");
//	  System.out.println("han b " + ball.x + " " + ball.y + " " + ball.dir + " ");

	  ball.vel *= SoccerLib.ball_decay;
	  ball.vel_x *= SoccerLib.ball_decay;
	  ball.vel_y *= SoccerLib.ball_decay;

        }

	/***************************/
	/* $@$3$3$GA4$F$N9TF0$r9M$($k(J*/
	/***************************/
	public void run()  
	{  
		ObjectInfo 	object;
		double 	   	dir,pow;
		Kick            kick = new Kick();

		long	base_time;      /* $@%5!<%P!<$H$N%?%$%_%s%0$r<h$k$?$a$N4pK\$H$J$k<B;~4V(J */
		long	sleep_time;     /* $@BT$A;~4V(J */
		long	tsee_time = 0;  /* $@A02s;HMQ$7$?(J,$@;k3P>pJs$rF@$?<B;~4V(J */

		String  str = null;
		byte    byt[] = null;

		base_time = tsee_time = System.currentTimeMillis();

	        object = m_memory.getObject("ball");  
		while(object == null)
		  {
    //		    System.out.println("Chase ball " + my.num);
		    SoccerLib.onestepwait();
		    object = m_memory.getObject("ball");  
		    aki.turn(20);
		  }


		while( !m_timeOver )  
		{

		        if( tsee_time != see_time)
			  {
			    object = m_memory.getObject("ball");  
			    calcpos.get_my_pos(m_memory);
			    tsee_time = see_time;

			    /*********************/
			    /*  $@%\!<%k$_$($k$H$-(J */
			    /*********************/
			    if(object != null)
			      {
			     // System.out.println("ball mieteru");
				ball.get_ballpos(object); 
			      }
			  }

			
//		    System.out.println(
//		      " x     "+((int)my.x)  +" y      "+((int)my.y)  +" dir    "+((int)my.dir)+"\n"+
//		       "ball_x "+((int)ball.x)+" ball_y "+((int)ball.y)+" ball_d "+//((int)ball.dir)+"\n");
//		       "\nba_dis "+((int)ball.dis)+" ba_dir "+((int)ball.dir)+"\n");

			// System.out.println(my.mode);

			/*****************************/
			/* $@%2!<%`%b!<%I(J4($@%W%l%$0J30(J) */ 	
			/*****************************/
			if(my.mode == 4)
			{
			  cskill.initialize();
			}
			/**************************/
			/* $@E(%A!<%`$N%U%j!<%-%C%/(J */
			/**************************/
			else if(my.mode == 3)
			{
//				System.out.println("Opponent Free Kick!");
				if(object != null)
				{
					aki.turn(ball.dir);
				}
				else
				{
					aki.turn(30.0);
				}
			}
			/************************/
			/*  tsujou-no-play-mode */
			/************************/
			else  {
			  /* if (my.pursue_flag)
			      {
  			        cskill.pursue();
				System.out.println("pursue");
			      }
    			    else
			    if(my.offside_flag)
			      {
				cskill.offtai();
			      }
			    else if((my.num == 2 || my.num == 3) && 
			       SoccerLib.Chase_decision() == false && 
			       my.pursue_flag == false && 
			       (my.time%(110+my.num*25)) == 0 &&
			       (PlayerPos.my_pos[my.num-1][0]+5.0)>my.x)
			      {
				my.offside_flag = true;
				cskill.offtai();
			      }
		         */
			    /************************/
			    /* $@%\!<%k$,=3$l$kHO0OFb(J */
			    /************************/
			  // else  
			      if(ball.dis < SoccerLib.kick_able && object != null)  
			      {  
//				System.out.println("Kick ");
				kick.pass();
				aki.kick(MyBody.kick_pow,MyBody.kick_dir);
			      }  
			    /**********************/
			    /* $@%\!<%k$N5wN%$,1s$$(J */
			    /**********************/
			    /* $@%\!<%k$,DI$($kHO0O$J$i(J */
			    else if(SoccerLib.Chase_decision() && object != null) 
			      {	
				if( SoccerLib.Abs(ball.dir) > SoccerLib.check_angle(ball.dis)
				    && object != null)
				  {
    //				    System.out.println("Chase Turn ");
				    aki.turn(ball.dir); 
				  }
				else 
				  {
    //				    System.out.println("Chase Dash ");
				    if(my.mode == 2)
				      pow = 25.0;
				    else
				      pow = 80.0;
				    aki.dash(pow);  
				  }
			      }
			    /* $@%\!<%k$,DI$($J$:$K(J,$@<+J,$N%]%8%7%g%s$G$J$$>l9g(J */
			    else if(SoccerLib.Check_Pos()==false)
			      {
//				System.out.println("Go home ");
				cskill.go_home();
			      }
			    else if(object != null) 
			      {
//				System.out.println("ball turn ");
				aki.turn(ball.dir); 
			      }
			    else 
			      {
//				System.out.println("search turn ");
				aki.turn(SoccerLib.normal_range*0.75);
			      }
			} 

			handler();

			/*****************/
			/* 1$@%9%F%C%WBT$D(J */
			/*****************/
			sleep_time = SoccerLib.simulator_step - 
			  ((System.currentTimeMillis()-base_time)%SoccerLib.simulator_step);

			try
			{
				Thread.sleep(sleep_time);
			}
			catch(Exception e){}
			
		} 
	}  
	/*******************/
	/* coach's message */
	/*******************/
	
    public void hearFromCoach(int time, StringTokenizer tk)
    {
            int unum;
            String header;

            //System.out.println("message"+tk.nextToken());
  
        //      StringTokenizer tk = new StringTokenizer(message,"() ");
 
                //kas
                tk.nextToken();
        
                while(tk.hasMoreTokens()){

                        String head = tk.nextToken();                   
                
                        /*
                        if((head.equals(")")) ||( head == null)){
                                break;
                        }
                        */

                        //System.out.println(head);

                        try{    
                                
                                unum = Integer.parseInt(head);

                        }
                        catch(NumberFormatException e){
                        
                               return;
                        
                        }       
                        
                        header = tk.nextToken();

                        if (unum == MyBody.num){
                        
                          //I<+J,$KBP$9$k;X<($J$N$G2r<a$9$kB

                        MyBody.mode = 4;
                          if (header.equals("m")){
                            //I%^%s%^!<%/$N;X<($G$"$kB
                                parseMark(tk);

                          }else if (header.equals("z")){
                            //I<+J,$,<u$1;}$D%>!<%s$N;X<($G$"$kB
                                parseZone(tk);
                          
                          }else {
                //              System.out.println(header);
                //              System.exit(1);
                          }
                        
                        }else {
                          //I<+J,$KBP$9$k;X<($G$O$J$$$N$GHt$P$9B
                          int skip = 0;

                          if (header.equals("m")){
                            skip = 3;
                          }else if (header.equals("z")){
                            skip = 6;
                          }else{

                               System.out.println(header);
				new Exception();                       

                          }

                            for(int i = 1; i <= skip; i++){
                                        tk.nextToken();
                          //              System.out.println("skip!");
                            }
                        }
                        

                   

                }
    }
  public void parseZone(StringTokenizer tk){
    //status I$rJzoneI$K$b$I$9B
    MyBody.status = 0;

    //I;X<($K=>$C$F!"JzoneI$r=$@5$9$kB
    double x = (double)(Integer.parseInt(tk.nextToken())) / 10;
    double y = (double)(Integer.parseInt(tk.nextToken())) / 10;


        
    MyBody.mypos_x = x;
    MyBody.mypos_y = y;
        if (x >= 0 ){
                x = -2.0;
        }
    MyBody.move_x = x;
    MyBody.move_y = y;
    MyBody.max_x = (double)(Integer.parseInt(tk.nextToken())) / 10;
    MyBody.max_y = (double)(Integer.parseInt(tk.nextToken())) / 10;
    MyBody.min_x = (double)(Integer.parseInt(tk.nextToken())) / 10;
    MyBody.min_y = (double)(Integer.parseInt(tk.nextToken())) / 10;

  }

        public void parseMark(StringTokenizer tk){
                
                        MyBody.status = 1;


                        MyBody.targetUnum = Integer.parseInt(tk.nextToken());
                        MyBody.eneX = (double)(Integer.parseInt(tk.nextToken()
)) / 10;
                        MyBody.eneY = (double)(Integer.parseInt(tk.nextToken()
)) / 10;

        }

	/************/
        /* $@;k3P>pJs(J */
        /************/
	public void see(VisualInfo info)  
	{  
		see_time = System.currentTimeMillis();
		m_memory.store(info);  
	}  
  
	/****************************/
	/* $@%l%U%j!<$+$i$N%a%C%;!<%8(J */
	/****************************/
	 public void hear(int time, String message)
        {                  
		m_memory.jstore(message);
        } 

        /**************************/
        /* $@%W%l%$%d!<4V$ND03P>pJs(J */
        /**************************/
	public void hear(int time, int direction, int sn , String message)  
	{  
//	  System.out.println("receive\n"+message+" "+message.length()+"\n");

	  if(sn == n)		
          {
		  my.load_flag = true;
		  strobj = message;
	  }
	}  
} 
