/***********************************/
/*				   */
/*	     Kasuga.java	   */
/*	     $@%a%$%sItJ,(J		   */
/*				   */
/***********************************/

import java.io.*; 
import java.util.*;	
import java.net.*; 
import java.lang.*;	
import java.util.StringTokenizer; 

class Kasuga implements SendCommand,Serializable
{ 
	private DatagramSocket	 m_socket;	 
	private	InetAddress	 m_host;	 
	private int		 m_port; 
	private String		 m_team; 
	private SensorInput	 m_brain;	 
	private static final int MSG_SIZE = 3072; 


	public static void main(String a[]) 
		throws SocketException, IOException 
	{ 
		String	hostName = new String(""); 
		int	port = 6000; 
		String	team = new String("Saboten-Ice");
		try 
		{								 
			for( int c = 0 ; c < a.length ; c += 2 ) 
			{ 
				if( a[c].compareTo("-h") == 0 ) 
					hostName = a[c+1];
				else if( a[c].compareTo("-t") == 0 )
                                        team  = a[c+1];
                                else
                                        throw new Exception();
			}  
		} 
		catch(Exception e) 
		{ 
     			return;
		} 
 
		Kasuga player = new Kasuga(InetAddress.getByName(hostName), 
						port, team); 
		player.mainLoop();							 
	}   

	public Kasuga(InetAddress host, int port, String team)  
		throws SocketException 
	{ 
		m_socket = new DatagramSocket(); 
		m_host = host; 
		m_port = port; 
		m_team = team; 
	} 

	public void finalize() 
	{ 
		m_socket.close(); 
	} 

	/********************************/
	/* $@%a%$%s%k!<%W!&%=%1%C%H$^$o$j(J */
	/********************************/
	protected void mainLoop() throws IOException 
	{ 
		byte[] buffer = new byte[MSG_SIZE]; 
		DatagramPacket packet = new DatagramPacket(buffer, MSG_SIZE); 
		init(); 
		m_socket.receive(packet); 

		/* Brain$@%/%i%9!&%9%l%C%I$rF0$+$9(J */
		parseInitCommand(new String(buffer)); 
		m_port = packet.getPort(); 

		/* $@%$%s%U%)%a!<%7%g%s$NH=Dj$H=hM}(J */
		/****************/
		/* $@%a%$%s%k!<%W(J */
		/****************/
		while( true ) 
		{
			/**********************************/
			/* $@%5!<%P!<$+$i%a%C%;!<%8$N<u<h$j(J */
			/**********************************/
				parseSensorInformation(receive()); 
		}
	} 

/*************************************************************************/
/*************************************************************************/
/*************************************************************************/

	/**************/
	/* $@%3%^%s%I=8(J */
	/**************/
	public void move(double x, double y) 
	{ 
		send("(move " + Double.toString(x) + " " + Double.toString(y) + ")"); 
	} 
 
	public void turn(double moment) 
	{ 
		double tmp1,tmp2;
		moment = SoccerLib.restrict(moment);

		tmp1 = moment * (1.0 + 5.0 * MyBody.vel);
		tmp2 = SoccerLib.restrict(tmp1);
		if (tmp1 != 0) moment *= tmp2 / tmp1;

		send("(turn " + Double.toString(moment) + ")"); 

		MyBody.dir += moment;
		MyBody.dir = SoccerLib.restrict(MyBody.dir);		
		Ball.dir -= moment;
		Ball.dir = SoccerLib.restrict(Ball.dir);
	} 
 
	public void dash(double power) 
	{ 
		send("(dash " + Double.toString(power) + ")"); 
	} 
 
	public void kick(double pow, double dir) 
	{ 
	        Ball.vel_x += pow * SoccerLib.kick_rate * 
		  SoccerLib.Cos2Rad(dir + MyBody.dir);
	        Ball.vel_y += pow * SoccerLib.kick_rate * 
		  SoccerLib.Sin2Rad(dir + MyBody.dir);
		Ball.vel = SoccerLib.Calc_dis(Ball.vel_x, Ball.vel_y);
	        
		send("(kick " + Double.toString(pow) + " " +  
			Double.toString(dir) + ")"); 
	} 
 
	public void say(String message) 
	{
	        String message2 = message;
		send("(say "+MyBody.num+"  "+ message2 + ")"); 
	} 
 
	public void changeView(String angle , String quality) 
	{ 
		send("(change_view " + angle + " " + quality + ")"); 
	} 
  /* 
  **	private void init() 
  **	{ 
  **		send("(init " + m_team + ")"); 
  **	} 
  */
	private void init() 
	{ 
		send("(init " + m_team + "(version 4.00))"); 
	} 

	private void init(int i) 
	{ 
		send("(init " + m_team + "(version 4.00) (goalie))"); 
	} 
	
	private void init(int a,int b) 
	{ 
		send("(init " + m_team + "(version 4.00) (goalie))"); 
	} 

	private void sense_body() 
	{ 
		send("(sense body)"); 
	} 

	/*********************/
	/* $@%3%^%s%I=8(J $@$*$o$j(J */
	/*********************/	

/*************************************************************************/
/*************************************************************************/
/*************************************************************************/

	/************************/
	/* $@$W$l$$$d!<$N=i4|2=(J */
	/************************/
	protected void parseInitCommand(String message)	throws IOException 
	{ 
		StringTokenizer	tokenizer = new StringTokenizer(message,"() "); 
		if( tokenizer.nextToken().compareTo("init") != 0) 
		{ 
			throw new IOException(message); 
		} 
 
		MyBody.side = tokenizer.nextToken().charAt(0);		//side
		MyBody.num = convertUniformNumber(Integer.parseInt(tokenizer.nextToken()));
		/*
		MyBody.num  = Integer.parseInt(tokenizer.nextToken());	//player number 
		*/

		MyBody.mode = 4;

		m_brain = new Brain(this);

	} 
 
	/********************************/
	/*  convert uniform number      */
	/*     added 990724 by S.F      */
	/********************************/
	private int convertUniformNumber(int num){	

		//  moto no sebangou 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11
		int convertData[]= { 1, 2, 5,11, 8, 6,10, 7, 3, 9, 4};	        

		return convertData[num-1] ;

	}

	/********************************/
	/* $@%a%C%;!<%8$NH=CG(J,see$@$+(Jhear$@$+(J */
	/********************************/
	private void parseSensorInformation(String message) 
	{ 
	//    System.out.println(message);
	  //	if( message.charAt(1) == 's' && message.charAt(3) == 'e') 
		if( message.charAt(1) == 's') 
		{ 
		  
		  //		  System.out.println("NORMAL\n"+message);
		  VisualInfo	info = new VisualInfo(message); 
		  info.parse(); 
		  m_brain.see(info); 
		} 
		else if( message.charAt(1) == 'h' ) 
           	{
			parseHear(message); 
		}
	} 
 
	/****************/
	/* $@D03P>pJs$J$i(J */
	/****************/	
        private void parseHear(String message) 
	{ 
	    //System.out.println(message);
		StringTokenizer	tokenizer = new StringTokenizer(message,"() "); 
		int	time; 
		int     dir;
		String sender; 
 
		tokenizer.nextToken(); 
		/* check refree or others  */
		time = Integer.parseInt( tokenizer.nextToken() ); 
		sender = tokenizer.nextToken(); 
		 
		if( sender.compareTo("referee") == 0 ) {
                                m_brain.hear(time, tokenizer.nextToken()); 
 
		}else if(sender.compareTo("online_coach_right") == 0 ||
                                sender.compareTo("online_coach_left") == 0){

                        if (sender.charAt(13) == MyBody.side){

                                m_brain.hearFromCoach(time, tokenizer);

                        }

		}else if( sender.compareTo("self") != 0 ) 

		{
		    dir  = Integer.parseInt(sender); 
			m_brain.hear(time,dir, Integer.parseInt(sender),  
			tokenizer.nextToken()); 
		}
	}
 
	/********************/
	/* $@%3%^%s%I$r$*$/$k(J */
	/********************/
	private void send(String message) 
	{ 
		byte[] buffer = new byte[MSG_SIZE]; 
//		message.getBytes(0,s.length(),buffer,0);
		buffer = message.getBytes();
 		DatagramPacket packet = new DatagramPacket(buffer, 
					buffer.length, m_host, m_port); 
		try
		{ 
			m_socket.send(packet); 
		}
		catch(IOException e)
		{ 
			System.err.println("socket sending error " + e); 
		} 
	} 

	private void send(byte[] buffer) 
	{ 
//		message.getBytes(0,s.length(),buffer,0);
 		DatagramPacket packet = new DatagramPacket(buffer, 
					buffer.length, m_host, m_port); 
		try
		{ 
			m_socket.send(packet); 
		}
		catch(IOException e)
		{ 
			System.err.println("socket sending error " + e); 
		} 
	} 
 
	/****************/
	/* $@%l%7!<%VItJ,(J */
	/****************/
	private String receive()  
	{ 
		byte[] buffer = new byte[MSG_SIZE]; 
		DatagramPacket packet = new DatagramPacket(buffer, MSG_SIZE); 
		try
		{ 
			m_socket.receive(packet); 
		}
		catch(IOException e)
		{ 
			System.err.println("socket receiving error " + e); 
		} 
		return new String(buffer); 
	} 
 
} 
 

 
 
 
 
 
 
 
 

